From iris.base_logic.lib Require Export own.
From iris.base_logic.lib Require Import fancy_updates.
From iris.proofmode Require Import tactics monpred.
From iris.bi Require Export monpred.
From iris.bi Require Import big_op.
From cosmo.lang Require Export lang.

(* TODO : move this to Iris. *)
Lemma monPred_in_bot {I : biIndex} {PROP : bi} `{!BiIndexBottom bot} :
  bi_entails (PROP := monPredI I PROP) True (monPred_in bot).
Proof. iStartProof PROP. iIntros (i) "_". by iPureIntro. Qed.

Canonical Structure lat_bi_index (Lat : latticeT) :=
  {| bi_index_type := Lat |}.
Instance lat_bi_index_bot (Lat : latticeT) (bot : Lat) :
  LatBottom bot → BiIndexBottom bot.
Proof. done. Qed.

Canonical Structure view_bi_index :=
  {| bi_index_type := view |}.

(* Types of view predicates. *)
Definition vProp Σ := monPred view_bi_index (uPredI (iResUR Σ)).
Definition vPropO Σ := monPredO view_bi_index (uPredI (iResUR Σ)).
Definition vPropI Σ := monPredI view_bi_index (uPredI (iResUR Σ)).

Hint Extern 10 (IsBiIndexRel _ _) => unfold IsBiIndexRel; solve_lat
            : typeclass_instances.

Global Instance into_sep_monPred_in V1 V2 :
  IntoSep (PROP := vPropI Σ) (monPred_in (V1 ⊔ V2)) (monPred_in V1) (monPred_in V2).
Proof. split => ?. rewrite monPred_at_sep. iPureIntro. split; solve_lat. Qed.

Global Instance from_sep_monPred_in V1 V2 :
  FromSep (PROP := vPropI Σ) (monPred_in (V1 ⊔ V2)) (monPred_in V1) (monPred_in V2).
Proof. split => ?. rewrite monPred_at_sep. iPureIntro. intros [??] ; solve_lat. Qed.

Global Instance into_and_monPred_in V1 V2 p :
  IntoAnd (PROP := vPropI Σ) p (monPred_in (V1 ⊔ V2)) (monPred_in V1) (monPred_in V2).
Proof.
  split => ?. destruct p ; rewrite /= 2?monPred_at_intuitionistically monPred_at_and ;
  iPureIntro ; split ; solve_lat.
Qed.

Global Instance from_and_monPred_in V1 V2 :
  FromAnd (PROP := vPropI Σ) (monPred_in (V1 ⊔ V2)) (monPred_in V1) (monPred_in V2).
Proof. split => ?. rewrite monPred_at_and. iPureIntro. intros [??] ; solve_lat. Qed.
